# from C:\Users\acbauer\My Documents\EdwardsAFB
#C:\Users\acbauer\My Documents\EdwardsAFB>start "sample" "c:\Program Files (x86)\ParaView 4.0.1\bin/pvpython.exe" candriver.py cancatalystscript.py can.ex2

import sys
if len(sys.argv) != 3:
    print "command is 'python <python driver code> <script name> <location of can.ex2>'"
    sys.exit(1)
import paraview
import paraview.vtk as vtk
import paraview.simple as pvsimple

# initialize and read input parameters
paraview.options.batch = True
paraview.options.symmetric = True

def _refHolderMaker(obj):
    def _refHolder(obj2, string):
        tmp = obj
    return _refHolder

def coProcess(grid, time, step, scriptname):
    #import vtkCoProcessorPython # import libvtkCoProcessorPython for older PV versions
    import vtkPVCatalystPython as vtkCoProcessorPython
    if scriptname.endswith(".py"):
        scriptname = scriptname[0:len(scriptname)-3]#scriptname.rstrip(".py")
    try:
        cpscript = __import__(scriptname)
    except:
        print 'Cannot find ', scriptname, ' -- no coprocessing will be performed.'
        return

    datadescription = vtkCoProcessorPython.vtkCPDataDescription()
    datadescription.SetTimeData(time, step)
    datadescription.AddInput("input")
    cpscript.RequestDataDescription(datadescription)
    inputdescription = datadescription.GetInputDescriptionByName("input")
    if inputdescription.GetIfGridIsNecessary() == False:
        return

    inputdescription.SetGrid(grid)
    cpscript.DoCoProcessing(datadescription)


#input_ds = ExodusIIReader( FileName=['c:/Users/acbauer/Documents/EdwardsAFB/can.ex2'])
input_ds = pvsimple.ExodusIIReader( FileName=[sys.argv[2]])

input_ds.ElementVariables = ['EQPS']
input_ds.EdgeBlocks = []
input_ds.GlobalVariables = ['KE', 'XMOM', 'YMOM', 'ZMOM', 'NSTEPS', 'TMSTEP']
input_ds.ElementBlocks = ['Unnamed block ID: 1 Type: HEX', 'Unnamed block ID: 2 Type: HEX']
input_ds.PointVariables = ['DISPL', 'VEL', 'ACCL']
input_ds.FaceBlocks = []

timeArray = input_ds.TimestepValues

for step in range(len(timeArray)):
    time = input_ds.TimestepValues[step]
    input_ds.UpdatePipeline(time)
    dataset = input_ds.GetClientSideObject().GetOutputDataObject(0)

    # "perform" coprocessing.  results are outputted only if
    # the passed in script says we should at time/step
    coProcess(dataset, time, step, sys.argv[1])
