# from c:\Users\acbauer\Documents\EdwardsAFB do:
#start "simrun" "c:\Program Files (x86)\ParaView 4.0.1\bin/pvpython.exe" livecoprocessing.py can.ex2

import sys
if len(sys.argv) != 2:
    print "command is 'python <python driver code> <location of can.ex2>'"
    sys.exit(1)


from paraview.simple import *
import vtkPVVTKExtensionsCorePython
import time

try: paraview.simple
except: from paraview.simple import *

from paraview import coprocessing
import vtkPVCatalystPython as vtkCoProcessorPython


#--------------------------------------------------------------
# Code generated from cpstate.py to create the CoProcessor.


# ----------------------- CoProcessor definition -----------------------

def CreateCoProcessor():
  def _CreatePipeline(coprocessor, datadescription):
    class Pipeline:
      can_ex2 = coprocessor.CreateProducer( datadescription, "input" )
      
    return Pipeline()

  class CoProcessor(coprocessing.CoProcessor):
    def CreatePipeline(self, datadescription):
      self.Pipeline = _CreatePipeline(self, datadescription)

  coprocessor = CoProcessor()
  freqs = {'input': []}
  coprocessor.SetUpdateFrequencies(freqs)
  return coprocessor

#--------------------------------------------------------------
# Global variables that will hold the pipeline for each timestep
# Creating the CoProcessor object, doesn't actually create the ParaView pipeline.
# It will be automatically setup when coprocessor.UpdateProducers() is called the
# first time.
coprocessor = CreateCoProcessor()

#--------------------------------------------------------------
# Enable Live-Visualizaton with ParaView
coprocessor.EnableLiveVisualization(True)


# ---------------------- Data Selection method ----------------------

def RequestDataDescription(datadescription):
    "Callback to populate the request for current timestep"
    global coprocessor
    if datadescription.GetForceOutput() == True:
        # We are just going to request all fields and meshes from the simulation
        # code/adaptor.
        for i in range(datadescription.GetNumberOfInputDescriptions()):
            datadescription.GetInputDescription(i).AllFieldsOn()
            datadescription.GetInputDescription(i).GenerateMeshOn()
        return

    # setup requests for all inputs based on the requirements of the
    # pipeline.
    coprocessor.LoadRequestedData(datadescription)

# ------------------------ Processing method ------------------------

def DoCoProcessing(datadescription):
    "Callback to do co-processing for current timestep"
    global coprocessor

    # Update the coprocessor by providing it the newly generated simulation data.
    # If the pipeline hasn't been setup yet, this will setup the pipeline.
    coprocessor.UpdateProducers(datadescription)

    # Write output data, if appropriate.
    coprocessor.WriteData(datadescription);

    # Write image capture (Last arg: rescale lookup table), if appropriate.
    coprocessor.WriteImages(datadescription, rescale_lookuptable=False)

    # Live Visualization, if enabled.
    coprocessor.DoLiveVisualization(datadescription, "localhost", 22222)


input_ds = ExodusIIReader( FileName=[sys.argv[1]])

input_ds.ElementVariables = ['EQPS']
input_ds.EdgeBlocks = []
input_ds.GlobalVariables = ['KE', 'XMOM', 'YMOM', 'ZMOM', 'NSTEPS', 'TMSTEP']
input_ds.ElementBlocks = ['Unnamed block ID: 1 Type: HEX', 'Unnamed block ID: 2 Type: HEX']
input_ds.PointVariables = ['DISPL', 'VEL', 'ACCL']
input_ds.FaceBlocks = []
Delete()

timeArray = input_ds.TimestepValues

# Create pipeline
currentTime = timeArray[0]
input_ds.UpdatePipeline()
pd = input_ds.GetClientSideObject().GetOutputDataObject(0)
producer = TrivialProducer()
producer.GetClientSideObject().SetOutput(pd)
ProcessIdScalars()
ExtractSurface2 = ExtractSurface()
rep = Show()

# Setup view
view = GetRenderView()
view.CameraViewUp = [0.0, 0.0, 1.0]
view.CameraPosition = [0.21706008911132812, -49.98501866535996, -5.110947132110596]
view.CameraFocalPoint = [0.21706008911132812, 4.0, -5.110947132110596]
view.CameraClippingRange = [45.485168478706356, 64.81479394534037]

rep.ColorArrayName = 'DISPL'
anim = GetAnimationScene()
view.ViewTime = currentTime
anim.AnimationTime = currentTime

# Init live visualization
from paraview import coprocessing
coprocessor.EnableLiveVisualization(True)

step = 0
while True:
  for currentTime in timeArray:
     print "Time: ", currentTime

     # update trivial producer
     input_ds.UpdatePipeline(currentTime)
     pd = input_ds.GetClientSideObject().GetOutputDataObject(0)
     producer.GetClientSideObject().SetOutput(pd)

     view.ViewTime = currentTime
     anim.AnimationTime = currentTime
     Render()
     datadescription = vtkCoProcessorPython.vtkCPDataDescription()
     datadescription.SetTimeData(step, step)
     datadescription.AddInput("input")
     inputdescription = datadescription.GetInputDescriptionByName("input")
     inputdescription.SetGrid(pd)


     #coprocessing.DoLiveVisualization(datadescription, "localhost", 22222)
     coprocessor.DoLiveVisualization(datadescription, "localhost", 22222)

     time.sleep(.1)
     step = step + 1
